<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
//
// +----------------------------------------------------------------------+
// | PHP Version 4                                                        |
// +----------------------------------------------------------------------+
// | Copyright (c) 1997-2002 The PHP Group                                |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.02 of the PHP license,      |
// | that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at                           |
// | http://www.php.net/license/2_02.txt.                                 |
// | If you did not receive a copy of the PHP license and are unable to   |
// | obtain it through the world-wide-web, please send a note to          |
// | license@php.net so we can mail you a copy immediately.               |
// +----------------------------------------------------------------------+
// | Authors: Alexander Zhukov <alex@veresk.ru> Original port from Python |
// | Authors: Harry Fuecks <hfuecks@phppatterns.com> Port to PEAR + more  |
// +----------------------------------------------------------------------+
//
// $Id$
//
/**
 * State machine serves as "memory" for HTMLSax
 * @author Alexander Zhukov <alex@veresk.ru>
 * @author Harry Fuecks <hfuecks@phppatterns.com>
 * @access protected
 * @package XML_HTMLSax
 */

class State_Machine
{
    // Used by XML_HTMLSax
    /**
     * Marks '<' event
     * @var boolean
     */
    var $left_b;

    /**
     * Marks '>' event
     * @var boolean
     */
    var $right_b;

    /**
     * Marks XML textnode beginning
     * @var boolean
     */
    var $text_node_start;

    /**
     * Marks XML textnode end
     * @var boolean
     */
    var $text_node_end;

    /**
     * Instructs HTML_Parser_Sax to ignore HTML entities '<' and '>'
     * @var boolean
     */
    var $ignore_entities;

    /**
     * Marks the current section of the document as "owned" by one of
     * the handlers below
     * @var boolean
     */
    var $owned;

    /**
     * Marks a processing instuction
     * @var boolean
     */
    var $pi;

    /**
     * Marks an escape XML section <! >
     * @var boolean
     */
    var $escape;

    /**
     * Marks JASP blocks <% %>
     * @var boolean
     */
    var $jasp;

    // Used by Attributes_Parser
    /**
     * Marks the start of an attribute name
     * @var boolean
     */
    var $att_name_start;

    /**
     * Marks the end of an attribute name
     * @var boolean
     */
    var $att_name_end;

    /**
     * Marks the start of an attribute value
     * @var boolean
     */
    var $att_val_start;

    /**
     * Marks the end of an attribute value
     * @var boolean
     */
    var $att_val_end;

    /**
     * Marks quotes / apostophies
     * @var boolean
     */
    var $quote;

    /**
     * Constructs StateMachine
     */
    function State_Machine()
    {
        $this->resetAll();
    }

    /**
     * Sets all state variables to false
     *
     * @return void
     * @access protected
     */
    function resetAll() 
    {
        $myVars = get_object_vars($this);
        foreach ( $myVars as $name => $value )
        {
            $this->{$name} = false;
        }
    }
}
?>